#lang racket/base

;; Example by Danny Yoo on the Racket mailing list
;; Mon, Dec 12, 2011 at 22:08

#||||||||||||||||||||||||||||||||||||||||||||||||
From: J G Cho <gcho@fundingmatters.com>
Date: Mon, Dec 12, 2011 at 21:49
Subject: [racket] In rkt or scheme, is there way to refer to the value of last expression?
To: Racket mailing list <users@racket-lang.org>


Just for the readability, is it possible to write

some-list
(proc-1 some-list)
(proc-2 (val-of-last-expression))
...
(proc-n (val-of-last-expression)) ;where n is 'largeish'

instead of

(proc-n ... (proc-2 (proc-1 some-list))))))))))))

Just curious,

jGc
||||||||||||||||||||||||||||||||||||||||||||||||#

(require (for-syntax racket/base)
         racket/stxparam)

(define-syntax-parameter it
  (lambda (stx)
    (raise-syntax-error #f "it should be used only in the context of a
begin/it" stx)))

(define-syntax (begin/it stx)
  (syntax-case stx ()
    [(_ b)
     #'b]
    [(_ b b-rest ...)
     (syntax/loc stx
       (let ([b-val b])
         (syntax-parameterize ([it
                                (make-rename-transformer #'b-val)])
                              (begin/it b-rest ...))))]))


(define (f x)
  (* x x))
(define (g x) (* x x x))


;; Exercise:
(begin/it
  (+ 1 2)
  (f it)  ;; ... Um, didn't mean to swear there.
  (g it))

(g (f (+ 1 2)))
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;