#lang racket
(define-syntax-rule (tee body ...)
  (begin
    (displayln "Meu código-fonte é:")
    (pretty-display 'body) ...
    body ...))

;(define-syntax seja (make-rename-transformer #'let))
;(define-syntax se (make-rename-transformer #'if))
;(define-syntax quando (make-rename-transformer #'when))
;(define-syntax função (make-rename-transformer #'lambda))
;(define-syntax par? (make-rename-transformer #'even?))
;(define-syntax leia (make-rename-transformer #'read))
;(define-syntax mostre (make-rename-transformer #'display))
;(define-syntax bloco (make-rename-transformer #'begin))
;(define-syntax enquanto (make-rename-transformer #'while))
;(define-syntax não (make-rename-transformer #'not))
;(define-syntax número? (make-rename-transformer #'number?))

(define-syntax-rule (translate (from ...) (to ...))
  (begin (define-syntax to (make-rename-transformer (syntax from))) ...))

(translate
 (define let if when lambda even? read displayln begin not number? and)
 (defina seja se quando função par? leia mostre bloco não número? tudo-verdade))

;;; Código em português
(tee
(defina dobro (função (x) (* 2 x)))
(defina triplo (função (x) (* 3 x)))

(defina pede-número
  (função ()
    (mostre "Digite um número (0 para terminar): ")
    (leia)))

(seja repete ()
  (seja ([x (pede-número)])
    (quando (tudo-verdade (número? x) (não (zero? x)))
      (mostre (se (par? x)
                (triplo x)
                (dobro x)))
      (repete)))))

;;;;;; Testes em chinês ;;;;;;;
;; Posso definir normalmente funções com nome em chinês.
(define 渠淑淃溽
  (λ (ile)
    (> ile 5)))

;; E usar...
(渠淑淃溽 34)
;; => #t
(渠淑淃溽 4)
;; => #f

;; Posso criar um novo nome para `define' ou qualquer outra coisa.
;; Os dois nomes passam a existir e são sintaticamente equivalentes.
(define-syntax 漌 (make-rename-transformer #'define))

;; Posso usar a nova sintaxe, em chinês, para definir uma mensagem.
(漌 msg "I can have `define' in Chinese!")

;; E mostrá-la.
(displayln msg)
;; => I can have `define' in Chinese!

;; Também é possível dar um novo nome localmente.
;; Note que f e x passam a ser sintaticamente a mesma coisa,
;; então alterar o valor de f é o mesmo que alterar o valor
;; de x.
(let ([x 3])
  (let-syntax ([f (make-rename-transformer #'x)])
    (set! f 6)
    (set! x (add1 x))
    f))
;; => 7